using System;
using System.Diagnostics;

using System.Collections.Generic;
using System.IO;
using System.Globalization;
using System.Net.Http;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;
using System.Net.Http.Headers;
using System.Text;

namespace OSS
{
    class TestTextTags20230413
    {


        public static void Main(string[] args)
        {
            string apiKey = "NGhxxxFNvRg==";
            string apiUrl = "https://sandbox.esignlive.com/api";
            string filePath = "...\\text tag - Copy (3).docx";

            //step1: create transaction and leave it in DRAFT status
            string jsonString = "{\"documents\":[{\"id\":\"Document1\",\"name\":\"Document1\",\"extract\":true,\"extractionTypes\":[\"TEXT_TAGS\"]}],\"status\":\"DRAFT\",\"type\":\"PACKAGE\",\"roles\":[{\"id\":\"s1\",\"signers\":[{\"email\":\"signer1.oss@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"s1\"}],\"name\":\"s1\"},{\"id\":\"s2\",\"signers\":[{\"email\":\"signer2.oss@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Doe\",\"id\":\"s2\"}],\"name\":\"s2\"}],\"name\":\"Text Tags Example Package\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(filePath);
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri($"{apiUrl}/packages"), form).Result;
            JObject packageIdJSON = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            string packageId = packageIdJSON["id"].ToString();
            Debug.WriteLine("Package ID: " + packageId);

            //step2: get package JSON after auto-extraction
            HttpClient myClient2 = new HttpClient();
            myClient2.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient2.DefaultRequestHeaders.Add("Accept", "application/json");
            var response2 = myClient2.GetAsync(new Uri($"{apiUrl}/packages/{packageId}")).Result;


            JObject packageJSON = JObject.Parse(response2.Content.ReadAsStringAsync().Result);
            Dictionary<string, Boolean> signerHasSignature = new Dictionary<string, bool>
            {
                ["s1"] = false,
                ["s2"] = false,
            };


            JArray documentsArray = packageJSON["documents"] as JArray;
            foreach (JObject documentJSON in documentsArray)
            {
                //My sandbox account has a default consent for all recipients, so I am only checking Document1
                if ((string)documentJSON["id"] == "Document1") {
                    JArray approvalsArray = documentJSON["approvals"] as JArray;
                    foreach (JObject approvalJSON in approvalsArray)
                    {
                        string roleId = approvalJSON["role"].ToString();
                        if (signerHasSignature.ContainsKey(roleId)) {
                            signerHasSignature[roleId] = true;
                        }
                    }
                }
            }


            //step3: remove recipients who don't have accept-only or signature
            foreach (var signerStatus in signerHasSignature)
            {
                string roleId = signerStatus.Key;
                Boolean hasSignature = signerStatus.Value;
                if (!hasSignature) {
                    HttpClient myClient3 = new HttpClient();
                    myClient3.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
                    myClient3.DefaultRequestHeaders.Add("Accept", "application/json");
                    var response3 = myClient3.DeleteAsync(new Uri($"{apiUrl}/packages/{packageId}/roles/{roleId}")).Result;
                    Debug.WriteLine("Remove Role ID: " + roleId);
                }
            }

            //step4: send transaction
            HttpClient myClient4 = new HttpClient();
            myClient4.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient4.DefaultRequestHeaders.Add("Accept", "application/json");
            StringContent jsonContent2 = new StringContent("{\"status\":\"SENT\"}", Encoding.UTF8, "application/json");
            var response4 = myClient4.PostAsync(new Uri($"{apiUrl}/packages/{packageId}"), jsonContent2).Result;


        }

    }
}